diff --git a/gdb/dwarf2/cu.c b/gdb/dwarf2/cu.c
index a64cb1d8380..e51ac900ea3 100644
--- a/gdb/dwarf2/cu.c
+++ b/gdb/dwarf2/cu.c
@@ -34,6 +34,7 @@ dwarf2_cu::dwarf2_cu (dwarf2_per_cu_data *per_cu,
     checked_producer (false),
     producer_is_gxx_lt_4_6 (false),
     producer_is_gcc_lt_4_3 (false),
+    producer_is_gcc_lt_11 (false),
     producer_is_gcc_11 (false),
     producer_is_icc (false),
     producer_is_icc_lt_14 (false),
diff --git a/gdb/dwarf2/cu.h b/gdb/dwarf2/cu.h
index 58e89960aad..190d395159d 100644
--- a/gdb/dwarf2/cu.h
+++ b/gdb/dwarf2/cu.h
@@ -256,6 +256,7 @@ struct dwarf2_cu
   bool checked_producer : 1;
   bool producer_is_gxx_lt_4_6 : 1;
   bool producer_is_gcc_lt_4_3 : 1;
+  bool producer_is_gcc_lt_11 : 1;
   bool producer_is_gcc_11 : 1;
   bool producer_is_icc : 1;
   bool producer_is_icc_lt_14 : 1;
diff --git a/gdb/dwarf2/macro.c b/gdb/dwarf2/macro.c
index a511d0a3b44..fd081f3c1f9 100644
--- a/gdb/dwarf2/macro.c
+++ b/gdb/dwarf2/macro.c
@@ -480,6 +480,15 @@ dwarf_decode_macro_bytes (dwarf2_per_objfile *per_objfile,
       macinfo_type = (enum dwarf_macro_record_type) read_1_byte (abfd, mac_ptr);
       mac_ptr++;
 
+      if (section_is_gnu && cu->dwo_unit != nullptr
+	  && cu->per_cu->version () >= 5 && producer_is_gcc_lt_11 (cu))
+	{
+	  if (macinfo_type == DW_MACRO_define_strp)
+	    macinfo_type = DW_MACRO_define_strx;
+	  else if (macinfo_type == DW_MACRO_undef_strp)
+	    macinfo_type = DW_MACRO_undef_strx;
+	}
+
       /* Note that we rely on the fact that the corresponding GNU and
 	 DWARF constants are the same.  */
       DIAGNOSTIC_PUSH
@@ -850,6 +859,15 @@ dwarf_decode_macros (dwarf2_per_objfile *per_objfile,
       macinfo_type = (enum dwarf_macro_record_type) read_1_byte (abfd, mac_ptr);
       mac_ptr++;
 
+      if (section_is_gnu && cu->dwo_unit != nullptr
+	  && cu->per_cu->version () >= 5 && producer_is_gcc_lt_11 (cu))
+	{
+	  if (macinfo_type == DW_MACRO_define_strp)
+	    macinfo_type = DW_MACRO_define_strx;
+	  else if (macinfo_type == DW_MACRO_undef_strp)
+	    macinfo_type = DW_MACRO_undef_strx;
+	}
+
       /* Note that we rely on the fact that the corresponding GNU and
 	 DWARF constants are the same.  */
       DIAGNOSTIC_PUSH
diff --git a/gdb/dwarf2/read.c b/gdb/dwarf2/read.c
index 4884553000a..3c2698d6832 100644
--- a/gdb/dwarf2/read.c
+++ b/gdb/dwarf2/read.c
@@ -7268,6 +7268,16 @@ producer_is_gcc_lt_4_3 (struct dwarf2_cu *cu)
   return cu->producer_is_gcc_lt_4_3;
 }
 
+/* See dwarf2/read.h.  */
+bool
+producer_is_gcc_lt_11 (struct dwarf2_cu *cu)
+{
+  if (!cu->checked_producer)
+    check_producer (cu);
+
+  return cu->producer_is_gcc_lt_11;
+}
+
 /* See dwarf2/read.h.  */
 bool
 producer_is_clang (struct dwarf2_cu *cu)
@@ -11299,6 +11309,7 @@ check_producer (struct dwarf2_cu *cu)
     {
       cu->producer_is_gxx_lt_4_6 = major < 4 || (major == 4 && minor < 6);
       cu->producer_is_gcc_lt_4_3 = major < 4 || (major == 4 && minor < 3);
+      cu->producer_is_gcc_lt_11 = major < 11;
       cu->producer_is_gcc_11 = major == 11;
     }
   else if (producer_is_icc (cu->producer, &major, &minor))
diff --git a/gdb/dwarf2/read.h b/gdb/dwarf2/read.h
index 7ab61528ab7..7fca859c43d 100644
--- a/gdb/dwarf2/read.h
+++ b/gdb/dwarf2/read.h
@@ -818,6 +818,10 @@ extern void dwarf2_get_section_info (struct objfile *,
 				     asection **, const gdb_byte **,
 				     bfd_size_type *);
 
+/* Return true if the producer of the inferior is gcc, and earlier than
+   gcc 11.  */
+extern bool producer_is_gcc_lt_11 (struct dwarf2_cu *cu);
+
 /* Return true if the producer of the inferior is clang.  */
 extern bool producer_is_clang (struct dwarf2_cu *cu);
 
diff --git a/gdb/testsuite/gdb.base/fission-macro-i.exp b/gdb/testsuite/gdb.base/fission-macro-i.exp
index bf1ca206a6c..3121e1d289b 100644
--- a/gdb/testsuite/gdb.base/fission-macro-i.exp
+++ b/gdb/testsuite/gdb.base/fission-macro-i.exp
@@ -13,8 +13,7 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
-# Gcc 11 is the first release containing the fix for PR debug/99319.
-require {expr [gcc_major_version] >= 11}
+require {expr [gcc_major_version] >= 9}
 
 # Use a .i file instead of a .c file, to make sure that we only generate one
 # .debug_macros section, working around gcc PR debug/111409.