diff --git a/gdb/dwarf2/cu.c b/gdb/dwarf2/cu.c
index e51ac900ea3..9a5ee59bbcf 100644
--- a/gdb/dwarf2/cu.c
+++ b/gdb/dwarf2/cu.c
@@ -35,6 +35,7 @@ dwarf2_cu::dwarf2_cu (dwarf2_per_cu_data *per_cu,
     producer_is_gxx_lt_4_6 (false),
     producer_is_gcc_lt_4_3 (false),
     producer_is_gcc_lt_11 (false),
+    producer_is_gcc_lt_15 (false),
     producer_is_gcc_11 (false),
     producer_is_icc (false),
     producer_is_icc_lt_14 (false),
diff --git a/gdb/dwarf2/cu.h b/gdb/dwarf2/cu.h
index 190d395159d..875b0250e3e 100644
--- a/gdb/dwarf2/cu.h
+++ b/gdb/dwarf2/cu.h
@@ -257,6 +257,7 @@ struct dwarf2_cu
   bool producer_is_gxx_lt_4_6 : 1;
   bool producer_is_gcc_lt_4_3 : 1;
   bool producer_is_gcc_lt_11 : 1;
+  bool producer_is_gcc_lt_15 : 1;
   bool producer_is_gcc_11 : 1;
   bool producer_is_icc : 1;
   bool producer_is_icc_lt_14 : 1;
diff --git a/gdb/dwarf2/macro.c b/gdb/dwarf2/macro.c
index fd081f3c1f9..10daca2cc54 100644
--- a/gdb/dwarf2/macro.c
+++ b/gdb/dwarf2/macro.c
@@ -481,7 +481,8 @@ dwarf_decode_macro_bytes (dwarf2_per_objfile *per_objfile,
       mac_ptr++;
 
       if (section_is_gnu && cu->dwo_unit != nullptr
-	  && cu->per_cu->version () >= 5 && producer_is_gcc_lt_11 (cu))
+	  && ((cu->per_cu->version () <= 4 && producer_is_gcc_lt_15 (cu))
+	      || (cu->per_cu->version () >= 5 && producer_is_gcc_lt_11 (cu))))
 	{
 	  if (macinfo_type == DW_MACRO_define_strp)
 	    macinfo_type = DW_MACRO_define_strx;
@@ -860,7 +861,8 @@ dwarf_decode_macros (dwarf2_per_objfile *per_objfile,
       mac_ptr++;
 
       if (section_is_gnu && cu->dwo_unit != nullptr
-	  && cu->per_cu->version () >= 5 && producer_is_gcc_lt_11 (cu))
+	  && ((cu->per_cu->version () <= 4 && producer_is_gcc_lt_15 (cu))
+	      || (cu->per_cu->version () >= 5 && producer_is_gcc_lt_11 (cu))))
 	{
 	  if (macinfo_type == DW_MACRO_define_strp)
 	    macinfo_type = DW_MACRO_define_strx;
diff --git a/gdb/dwarf2/read.c b/gdb/dwarf2/read.c
index e5f65ad28f2..6a489502f8b 100644
--- a/gdb/dwarf2/read.c
+++ b/gdb/dwarf2/read.c
@@ -7278,6 +7278,16 @@ producer_is_gcc_lt_11 (struct dwarf2_cu *cu)
   return cu->producer_is_gcc_lt_11;
 }
 
+/* See dwarf2/read.h.  */
+bool
+producer_is_gcc_lt_15 (struct dwarf2_cu *cu)
+{
+  if (!cu->checked_producer)
+    check_producer (cu);
+
+  return cu->producer_is_gcc_lt_15;
+}
+
 /* See dwarf2/read.h.  */
 bool
 producer_is_clang (struct dwarf2_cu *cu)
@@ -11310,6 +11320,7 @@ check_producer (struct dwarf2_cu *cu)
       cu->producer_is_gxx_lt_4_6 = major < 4 || (major == 4 && minor < 6);
       cu->producer_is_gcc_lt_4_3 = major < 4 || (major == 4 && minor < 3);
       cu->producer_is_gcc_lt_11 = major < 11;
+      cu->producer_is_gcc_lt_15 = major < 15;
       cu->producer_is_gcc_11 = major == 11;
     }
   else if (producer_is_icc (cu->producer, &major, &minor))
diff --git a/gdb/dwarf2/read.h b/gdb/dwarf2/read.h
index 7fca859c43d..d61985e4916 100644
--- a/gdb/dwarf2/read.h
+++ b/gdb/dwarf2/read.h
@@ -822,6 +822,10 @@ extern void dwarf2_get_section_info (struct objfile *,
    gcc 11.  */
 extern bool producer_is_gcc_lt_11 (struct dwarf2_cu *cu);
 
+/* Return true if the producer of the inferior is gcc, and earlier than
+   gcc 15.  */
+extern bool producer_is_gcc_lt_15 (struct dwarf2_cu *cu);
+
 /* Return true if the producer of the inferior is clang.  */
 extern bool producer_is_clang (struct dwarf2_cu *cu);
 
diff --git a/gdb/testsuite/gdb.base/fission-macro-i.exp b/gdb/testsuite/gdb.base/fission-macro-i.exp
index 62304f9b69e..01eb8c9ea84 100644
--- a/gdb/testsuite/gdb.base/fission-macro-i.exp
+++ b/gdb/testsuite/gdb.base/fission-macro-i.exp
@@ -66,10 +66,6 @@ proc do_tests { dwarf_version dwarf_bits strict_dwarf } {
 }
 
 foreach_with_prefix dwarf_version {4 5} {
-    if { $dwarf_version == 4 && [gcc_major_version] < 15 } {
-	# Gcc does not contain fix for PR debug/115066.
-	continue
-    }
     foreach_with_prefix dwarf_bits {32 64} {
 	foreach_with_prefix strict_dwarf {0 1} {
 	    do_tests $dwarf_version $dwarf_bits $strict_dwarf
diff --git a/gdb/testsuite/gdb.base/fission-macro.exp b/gdb/testsuite/gdb.base/fission-macro.exp
index 9e5d5c0a0d5..2434a329b7e 100644
--- a/gdb/testsuite/gdb.base/fission-macro.exp
+++ b/gdb/testsuite/gdb.base/fission-macro.exp
@@ -67,10 +67,6 @@ proc do_tests { dwarf_version dwarf_bits strict_dwarf } {
 }
 
 foreach_with_prefix dwarf_version {4 5} {
-    if { $dwarf_version == 4 && [gcc_major_version] < 15 } {
-	# Gcc does not contain fix for PR debug/115066.
-	continue
-    }
     foreach_with_prefix dwarf_bits {32 64} {
 	foreach_with_prefix strict_dwarf {0 1} {
 	    do_tests $dwarf_version $dwarf_bits $strict_dwarf